/**
  ******************************************************************************
  * @file    fm33a0xxev_rtc.h
  * @author  FM33A0XXEV Application Team
  * @version V1.0.0
  * @date    16-April-2020
  * @brief   This file contains all the functions prototypes for the RTC firmware library.  
  ******************************************************************************
  */
  
/* Define to prevent recursive inclusion -------------------------------------*/

#ifndef __FM33A0XXEV_RTC_H
#define __FM33A0XXEV_RTC_H


#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/

#include "FM33A0XXEV.h" 
  
typedef struct
{       
	uint8_t			Year;		/*!<RTC */
	uint8_t			Month;		/*!<RTC */
	uint8_t			Date;		/*!<RTC */	
	uint8_t			Hour;		/*!<RTC ʱ*/
	uint8_t			Minute;		/*!<RTC */	
	uint8_t			Second;		/*!<RTC */			
	uint8_t			Week;		/*!<RTC */	

}RTC_TimeDateTypeDef,RTC_StampTmieTypeDef;

typedef struct
{     
	uint8_t			Hour;		/*!<RTC ʱ*/		
	uint8_t			Minute;		/*!<RTC */
	uint8_t			Second;		/*!<RTC */

}RTC_AlarmTmieTypeDef;	 



#define RTC_WRITE_ENABLE    ((uint32)0xACACACAC)
#define RTC_WRITE_DISABLE   ((uint32)0x55AA55AA)	 
	 
#define	RTC_WER_RTCWE_Pos	0	/* RTCдʹܼĴ
CPURTCWEд0xACACACACʱCPURTCBCDʱĴдֵʱRTCWE1CPURTCWEд벻Ϊ0xACACACACֵʱָд,ʱRTCWE0 */
#define	RTC_WER_RTCWE_Msk	(0x1U << RTC_WER_RTCWE_Pos)

#define	RTC_IER_ADJ_IE_Pos	12	/* Ужʹܡ
1жʹܴ
0жʹֹܽ */
#define	RTC_IER_ADJ_IE_Msk	(0x1U << RTC_IER_ADJ_IE_Pos)
	/* жʹܴ */
	/* жʹֹܽ */

#define	RTC_IER_ALARM_IE_Pos	11	/* жʹܡ
1жʹܴ
0жʹֹܽ */
#define	RTC_IER_ALARM_IE_Msk	(0x1U << RTC_IER_ALARM_IE_Pos)
	/* жʹܴ */
	/* жʹֹܽ */

#define	RTC_IER_1KHZ_IE_Pos	10	/* 1khzжʹܡ
1жʹܴ
0жʹֹܽ */
#define	RTC_IER_1KHZ_IE_Msk	(0x1U << RTC_IER_1KHZ_IE_Pos)
	/* жʹܴ */
	/* жʹֹܽ */

#define	RTC_IER_256HZ_IE_Pos	9	/* 256hzжʹܡ
1жʹܴ
0жʹֹܽ */
#define	RTC_IER_256HZ_IE_Msk	(0x1U << RTC_IER_256HZ_IE_Pos)
	/* жʹܴ */
	/* жʹֹܽ */

#define	RTC_IER_16HZ_IE_Pos	7	/* 16hzжʹܡ
1жʹܴ
0жʹֹܽ */
#define	RTC_IER_16HZ_IE_Msk	(0x1U << RTC_IER_16HZ_IE_Pos)
	/* жʹܴ */
	/* жʹֹܽ */

#define	RTC_IER_8HZ_IE_Pos	6	/* 8hzжʹܡ
1жʹܴ
0жʹֹܽ */
#define	RTC_IER_8HZ_IE_Msk	(0x1U << RTC_IER_8HZ_IE_Pos)
	/* жʹܴ */
	/* жʹֹܽ */

#define	RTC_IER_4HZ_IE_Pos	5	/* 4hzжʹܡ
1жʹܴ
0жʹֹܽ */
#define	RTC_IER_4HZ_IE_Msk	(0x1U << RTC_IER_4HZ_IE_Pos)
	/* жʹܴ */
	/* жʹֹܽ */

#define	RTC_IER_2HZ_IE_Pos	4	/* 2hzжʹܡ
1жʹܴ
0жʹֹܽ */
#define	RTC_IER_2HZ_IE_Msk	(0x1U << RTC_IER_2HZ_IE_Pos)
	/* жʹܴ */
	/* жʹֹܽ */

#define	RTC_IER_SEC_IE_Pos	3	/* жʹܡ
1жʹܴ
0жʹֹܽ */
#define	RTC_IER_SEC_IE_Msk	(0x1U << RTC_IER_SEC_IE_Pos)
	/* жʹܴ */
	/* жʹֹܽ */

#define	RTC_IER_MIN_IE_Pos	2	/* жʹܡ
1жʹܴ
0жʹֹܽ */
#define	RTC_IER_MIN_IE_Msk	(0x1U << RTC_IER_MIN_IE_Pos)
	/* жʹܴ */
	/* жʹֹܽ */

#define	RTC_IER_HOUR_IE_Pos	1	/* Сʱжʹܡ
1жʹܴ
0жʹֹܽ */
#define	RTC_IER_HOUR_IE_Msk	(0x1U << RTC_IER_HOUR_IE_Pos)
	/* жʹܴ */
	/* жʹֹܽ */

#define	RTC_IER_DATE_IE_Pos	0	/* жʹܡ
1жʹܴ
0жʹֹܽ */
#define	RTC_IER_DATE_IE_Msk	(0x1U << RTC_IER_DATE_IE_Pos)
	/* жʹܴ */
	/* жʹֹܽ */

#define	RTC_ISR_ADJ_IF_Pos	12	/* Ужϱ־д1
1жλ
0жϲ */
#define	RTC_ISR_ADJ_IF_Msk	(0x1U << RTC_ISR_ADJ_IF_Pos)

#define	RTC_ISR_ALARM_IF_Pos	11	/* жϱ־д1
1жλ
0жϲ */
#define	RTC_ISR_ALARM_IF_Msk	(0x1U << RTC_ISR_ALARM_IF_Pos)

#define	RTC_ISR_1KHZ_IF_Pos	10	/* 1khzжϱ־д1
1жλ
0жϲ */
#define	RTC_ISR_1KHZ_IF_Msk	(0x1U << RTC_ISR_1KHZ_IF_Pos)

#define	RTC_ISR_256HZ_IF_Pos	9	/* 256hzжϱ־д1
1жλ
0жϲ */
#define	RTC_ISR_256HZ_IF_Msk	(0x1U << RTC_ISR_256HZ_IF_Pos)

#define	RTC_ISR_16HZ_IF_Pos	7	/* 16hzжϱ־д1
1жλ
0жϲ */
#define	RTC_ISR_16HZ_IF_Msk	(0x1U << RTC_ISR_16HZ_IF_Pos)

#define	RTC_ISR_8HZ_IF_Pos	6	/* 8hzжϱ־д1
1жλ
0жϲ */
#define	RTC_ISR_8HZ_IF_Msk	(0x1U << RTC_ISR_8HZ_IF_Pos)

#define	RTC_ISR_4HZ_IF_Pos	5	/* 4hzжϱ־д1
1жλ
0жϲ */
#define	RTC_ISR_4HZ_IF_Msk	(0x1U << RTC_ISR_4HZ_IF_Pos)

#define	RTC_ISR_2HZ_IF_Pos	4	/* 2hzжϱ־д1
1жλ
0жϲ */
#define	RTC_ISR_2HZ_IF_Msk	(0x1U << RTC_ISR_2HZ_IF_Pos)

#define	RTC_ISR_SEC_IF_Pos	3	/* жϱ־д1
1жλ
0жϲ */
#define	RTC_ISR_SEC_IF_Msk	(0x1U << RTC_ISR_SEC_IF_Pos)

#define	RTC_ISR_MIN_IF_Pos	2	/* жϱ־д1
1жλ
0жϲ */
#define	RTC_ISR_MIN_IF_Msk	(0x1U << RTC_ISR_MIN_IF_Pos)

#define	RTC_ISR_HOUR_IF_Pos	1	/* Сʱжϱ־д1
1жλ
0жϲ */
#define	RTC_ISR_HOUR_IF_Msk	(0x1U << RTC_ISR_HOUR_IF_Pos)

#define	RTC_ISR_DATE_IF_Pos	0	/* жϱ־д1
1жλ
0жϲ */
#define	RTC_ISR_DATE_IF_Msk	(0x1U << RTC_ISR_DATE_IF_Pos)

#define	RTC_BCDSEC_BCDSEC_Pos	0	/* ʱֵBCDʽ */
#define	RTC_BCDSEC_BCDSEC_Msk	(0x7fU << RTC_BCDSEC_BCDSEC_Pos)

#define	RTC_BCDMIN_BCDMIN_Pos	0	/* ʱֵBCDʽ */
#define	RTC_BCDMIN_BCDMIN_Msk	(0x7fU << RTC_BCDMIN_BCDMIN_Pos)

#define	RTC_BCDHOUR_BCDHOUR_Pos	0	/* СʱֵBCDʽ */
#define	RTC_BCDHOUR_BCDHOUR_Msk	(0x3fU << RTC_BCDHOUR_BCDHOUR_Pos)

#define	RTC_BCDDATE_BCDDATE_Pos	0	/* СʱֵBCDʽ */
#define	RTC_BCDDATE_BCDDATE_Msk	(0x3fU << RTC_BCDDATE_BCDDATE_Pos)

#define	RTC_BCDWEEK_BCDWEEK_Pos	0	/* ֵBCDʽ */
#define	RTC_BCDWEEK_BCDWEEK_Msk	(0x7U << RTC_BCDWEEK_BCDWEEK_Pos)

#define	RTC_BCDMONTH_BCDMONTH_Pos	0	/* ֵBCDʽ */
#define	RTC_BCDMONTH_BCDMONTH_Msk	(0x1fU << RTC_BCDMONTH_BCDMONTH_Pos)

#define	RTC_BCDYEAR_BCDYEAR_Pos	0	/* ֵBCDʽ */
#define	RTC_BCDYEAR_BCDYEAR_Msk	(0xffU << RTC_BCDYEAR_BCDYEAR_Pos)

#define	RTC_ALARM_ALMEN_Pos	31	/* ӹʹ (alarm enable)
1ʹAlarm
0ֹAlarm */
#define	RTC_ALARM_ALMEN_Msk	(0x1U << RTC_ALARM_ALMEN_Pos)
	/* ʹAlarm */
	/* ֹAlarm */

#define	RTC_ALARM_ALARMHOUR_Pos	16	/* ӵСʱֵ */
#define	RTC_ALARM_ALARMHOUR_Msk	(0x3fU << RTC_ALARM_ALARMHOUR_Pos)

#define	RTC_ALARM_ALARMMIN_Pos	8	/* ӵķֵ */
#define	RTC_ALARM_ALARMMIN_Msk	(0x7fU << RTC_ALARM_ALARMMIN_Pos)

#define	RTC_ALARM_ALARMSEC_Pos	0	/* ӵֵ */
#define	RTC_ALARM_ALARMSEC_Msk	(0x7fU << RTC_ALARM_ALARMSEC_Pos)

#define	RTC_TMSEL_FSEL_Pos	0	/* Ƶѡźţ
0000PLLƵõľȷ1뷽 
0001PLLƵĿɱռձȵľȷʱ 
0010λźţߵƽ1s
0011ּλźţߵƽ1s
0100Сʱλźţߵƽ1s
0101λźţߵƽ1s
0110ƥź
0111256뷽ź
1000PLLƵĿɱռձȵľȷʱ
1001λź
1010ּλź
1011Сʱλź
1100λź
1101ƥź
1110PLLƵľȷ1sź
1111RTCڲʱ귽 */
#define	RTC_TMSEL_FSEL_Msk	        (0xfU << RTC_TMSEL_FSEL_Pos)
#define	RTC_TMSEL_FSEL_PLL1HZ    	(0x0U << RTC_TMSEL_FSEL_Pos)// PLLƵõľȷ1뷽 
#define	RTC_TMSEL_FSEL_PLLD1HZ   	(0x1U << RTC_TMSEL_FSEL_Pos)//PLLƵĿɱռձȵľȷʱ 
#define	RTC_TMSEL_FSEL_SECOND    	(0x2U << RTC_TMSEL_FSEL_Pos)	/* 4b0010λźţߵƽ1s */
#define	RTC_TMSEL_FSEL_MINUTE    	(0x3U << RTC_TMSEL_FSEL_Pos)	/* 4b0011ּλźţߵƽ1s */
#define	RTC_TMSEL_FSEL_HOUR	      (0x4U << RTC_TMSEL_FSEL_Pos)	/* 4b0100Сʱλźţߵƽ1s */
#define	RTC_TMSEL_FSEL_DAY	        (0x5U << RTC_TMSEL_FSEL_Pos)	/* 4b0101λźţߵƽ1s */
#define	RTC_TMSEL_FSEL_ALARM	      (0x6U << RTC_TMSEL_FSEL_Pos)	/* 4b0110ƥź */
#define	RTC_TMSEL_FSEL_256S	      (0x7U << RTC_TMSEL_FSEL_Pos)	/* 4b0111128뷽ź */
#define	RTC_TMSEL_FSEL_PLLD1HZREV	(0x8U << RTC_TMSEL_FSEL_Pos)	/* 4b1000PLLƵĸߵƽ80msʱ */
#define	RTC_TMSEL_FSEL_SECONDREV	  (0x9U << RTC_TMSEL_FSEL_Pos)	/* 4b1001λź */
#define	RTC_TMSEL_FSEL_MINUTEREV	  (0xaU << RTC_TMSEL_FSEL_Pos)	/* 4b1010ּλź */
#define	RTC_TMSEL_FSEL_HOURREV	    (0xbU << RTC_TMSEL_FSEL_Pos)	/* 4b1011Сʱλź */
#define	RTC_TMSEL_FSEL_DAYREV	    (0xcU << RTC_TMSEL_FSEL_Pos)	/* 4b1100λź */
#define	RTC_TMSEL_FSEL_ALARMREV	  (0xdU << RTC_TMSEL_FSEL_Pos)	/* 4b1101ƥź */
#define	RTC_TMSEL_FSEL_PLL1HZREV	  (0xeU << RTC_TMSEL_FSEL_Pos)	/* 4b1110PLLƵľȷ1sź */
#define	RTC_TMSEL_FSEL_SECONDRUN	  (0xfU << RTC_TMSEL_FSEL_Pos)	/* 4b1111RTCڲʱ귽 */





#define	RTC_ADJUST_ADJUST_Pos	0	/* LTBCֵԭʽ */
#define	RTC_ADJUST_ADJUST_Msk	(0x1fffU << RTC_ADJUST_ADJUST_Pos)

#define	RTC_ADSIGN_ADSIGN_Pos	0	/* LTBC
0ʾӼֵ
1ʾټֵ */
#define	RTC_ADSIGN_ADSIGN_Msk	(0x1U << RTC_ADSIGN_ADSIGN_Pos)
#define	RTC_ADSIGN_ADSIGN_INCREASE	(0x0U << RTC_ADSIGN_ADSIGN_Pos)	/* ʾӼֵ */
#define	RTC_ADSIGN_ADSIGN_DECREASE	(0x1U << RTC_ADSIGN_ADSIGN_Pos)	/* ʾټֵ */

#define	RTC_VCAL_PR1SEN_Pos	0	/* Уʹź
0ʾֹУ
1ʾʹУ */
#define	RTC_VCAL_PR1SEN_Msk	(0x1U << RTC_VCAL_PR1SEN_Pos)
	/* ʾֹУ */
	/* ʾʹУ */

#define	RTC_MSCNT_MSCNT_Pos	0	/* 
CALSTEP=00/11Чλ8bit3.9ms
CALSTEP=01Чֵ7bit7.8ms
CALSTEP=10Чֵ6bit15.625ms */
#define	RTC_MSCNT_MSCNT_Msk	(0xffU << RTC_MSCNT_MSCNT_Pos)

#define	RTC_CALSTEP_CALSTEP_Pos	0	/* LTBCСУѡ
100.06ppm+/-0.03ppm
010.119ppm+/-0.06ppm
00/110.238ppm+/-0.119ppm */
#define	RTC_CALSTEP_CALSTEP_Msk	(0x1U << RTC_CALSTEP_CALSTEP_Pos)
#define	RTC_CALSTEP_CALSTEP_006PPM	(0x2U << RTC_CALSTEP_CALSTEP_Pos)	/* 0.06ppm+/-0.03ppm */
#define	RTC_CALSTEP_CALSTEP_0119PPM	(0x1U << RTC_CALSTEP_CALSTEP_Pos)	/* 0.119ppm+/-0.06ppm */
#define	RTC_CALSTEP_CALSTEP_0238PPM	(0x0U << RTC_CALSTEP_CALSTEP_Pos)	/* 0.238ppm+/-0.119ppm */

#define	RTC_ADCNT_ADJCNT_Pos	0
#define	RTC_ADCNT_ADJCNT_Msk	(0x1ffU << RTC_ADCNT_ADJCNT_Pos)

#define	RTC_SSR_SSR_Pos	0	/*  (sub-second counter register)
15.625ms */
#define	RTC_SSR_SSR_Msk	(0x3fU << RTC_SSR_SSR_Pos)

#define	RTC_SSA_SSAEN_Pos	7	/* ʹ (sub-second alarm enable)
1ʹӹ
0ֹӹ */
#define	RTC_SSA_SSAEN_Msk	(0x1U << RTC_SSA_SSAEN_Pos)
	/* ʹӹ */
	/* ֹӹ */

#define	RTC_SSA_SS_ALARM_Pos	0	/*  (sub-second alarm)
SSAEN=1SSRֵSS_ALARMʱжϱ־λ */
#define	RTC_SSA_SS_ALARM_Msk	(0x3fU << RTC_SSA_SS_ALARM_Pos)

#define	RTC_DTR_DUTY_Pos	0	/* RTC_Aʱռձȣ1ڸߵƽȣλĬֵ80msߵƽ */
#define	RTC_DTR_DUTY_Msk	(0x1ffffffU << RTC_DTR_DUTY_Pos)

#define	RTC_CR_RTC_EN_Pos	0	/* RTC_AʱӺʹ (RTC_A Enable)
1ʹRTCʱ
0ֹͣRTCʱ

˼ĴſLSCLK룬㣬RTCֹͣʱУܴܲ˼ĴӰ졣 */
#define	RTC_CR_RTC_EN_Msk	(0x1U << RTC_CR_RTC_EN_Pos)
	/* ʹRTCʱ */
	/* ֹͣRTCʱ */
//Macro_End

/* Exported functions --------------------------------------------------------*/ 
extern void RTC_Deinit(void);

/* RTCдʹܼĴ
CPURTCWEд0xACACACACʱCPURTCBCDʱĴдֵʱRTCWE1CPURTCWEд벻Ϊ0xACACACACֵʱָд,ʱRTCWE0 غ */


extern void RTC_TimeDate_SetEx(RTC_TimeDateTypeDef* para);
extern void RTC_TimeDate_GetEx(RTC_TimeDateTypeDef* para);

extern void RTC_WER_Write(uint32_t SetValue);
extern void RTC_WER_RTCWE_Setable(FunState NewState);
extern FunState RTC_WER_RTCWE_Getable(void);

/* Ужʹܡ
1жʹܴ
0жʹֹܽ غ */
extern void RTC_IER_ADJ_IE_Setable(FunState NewState);
extern FunState RTC_IER_ADJ_IE_Getable(void);

/* жʹܡ
1жʹܴ
0жʹֹܽ غ */
extern void RTC_IER_ALARM_IE_Setable(FunState NewState);
extern FunState RTC_IER_ALARM_IE_Getable(void);

/* 1khzжʹܡ
1жʹܴ
0жʹֹܽ غ */
extern void RTC_IER_1KHZ_IE_Setable(FunState NewState);
extern FunState RTC_IER_1KHZ_IE_Getable(void);

/* 256hzжʹܡ
1жʹܴ
0жʹֹܽ غ */
extern void RTC_IER_256HZ_IE_Setable(FunState NewState);
extern FunState RTC_IER_256HZ_IE_Getable(void);

/* 16hzжʹܡ
1жʹܴ
0жʹֹܽ غ */
extern void RTC_IER_16HZ_IE_Setable(FunState NewState);
extern FunState RTC_IER_16HZ_IE_Getable(void);

/* 8hzжʹܡ
1жʹܴ
0жʹֹܽ غ */
extern void RTC_IER_8HZ_IE_Setable(FunState NewState);
extern FunState RTC_IER_8HZ_IE_Getable(void);

/* 4hzжʹܡ
1жʹܴ
0жʹֹܽ غ */
extern void RTC_IER_4HZ_IE_Setable(FunState NewState);
extern FunState RTC_IER_4HZ_IE_Getable(void);

/* 2hzжʹܡ
1жʹܴ
0жʹֹܽ غ */
extern void RTC_IER_2HZ_IE_Setable(FunState NewState);
extern FunState RTC_IER_2HZ_IE_Getable(void);

/* жʹܡ
1жʹܴ
0жʹֹܽ غ */
extern void RTC_IER_SEC_IE_Setable(FunState NewState);
extern FunState RTC_IER_SEC_IE_Getable(void);

/* жʹܡ
1жʹܴ
0жʹֹܽ غ */
extern void RTC_IER_MIN_IE_Setable(FunState NewState);
extern FunState RTC_IER_MIN_IE_Getable(void);

/* Сʱжʹܡ
1жʹܴ
0жʹֹܽ غ */
extern void RTC_IER_HOUR_IE_Setable(FunState NewState);
extern FunState RTC_IER_HOUR_IE_Getable(void);

/* жʹܡ
1жʹܴ
0жʹֹܽ غ */
extern void RTC_IER_DATE_IE_Setable(FunState NewState);
extern FunState RTC_IER_DATE_IE_Getable(void);

/* Ужϱ־д1
1жλ
0жϲ غ */
extern void RTC_ISR_ADJ_IF_Clr(void);
extern FlagStatus RTC_ISR_ADJ_IF_Chk(void);

/* жϱ־д1
1жλ
0жϲ غ */
extern void RTC_ISR_ALARM_IF_Clr(void);
extern FlagStatus RTC_ISR_ALARM_IF_Chk(void);

/* 1khzжϱ־д1
1жλ
0жϲ غ */
extern void RTC_ISR_1KHZ_IF_Clr(void);
extern FlagStatus RTC_ISR_1KHZ_IF_Chk(void);

/* 256hzжϱ־д1
1жλ
0жϲ غ */
extern void RTC_ISR_256HZ_IF_Clr(void);
extern FlagStatus RTC_ISR_256HZ_IF_Chk(void);

/* 16hzжϱ־д1
1жλ
0жϲ غ */
extern void RTC_ISR_16HZ_IF_Clr(void);
extern FlagStatus RTC_ISR_16HZ_IF_Chk(void);

/* 8hzжϱ־д1
1жλ
0жϲ غ */
extern void RTC_ISR_8HZ_IF_Clr(void);
extern FlagStatus RTC_ISR_8HZ_IF_Chk(void);

/* 4hzжϱ־д1
1жλ
0жϲ غ */
extern void RTC_ISR_4HZ_IF_Clr(void);
extern FlagStatus RTC_ISR_4HZ_IF_Chk(void);

/* 2hzжϱ־д1
1жλ
0жϲ غ */
extern void RTC_ISR_2HZ_IF_Clr(void);
extern FlagStatus RTC_ISR_2HZ_IF_Chk(void);

/* жϱ־д1
1жλ
0жϲ غ */
extern void RTC_ISR_SEC_IF_Clr(void);
extern FlagStatus RTC_ISR_SEC_IF_Chk(void);

/* жϱ־д1
1жλ
0жϲ غ */
extern void RTC_ISR_MIN_IF_Clr(void);
extern FlagStatus RTC_ISR_MIN_IF_Chk(void);

/* Сʱжϱ־д1
1жλ
0жϲ غ */
extern void RTC_ISR_HOUR_IF_Clr(void);
extern FlagStatus RTC_ISR_HOUR_IF_Chk(void);

/* жϱ־д1
1жλ
0жϲ غ */
extern void RTC_ISR_DATE_IF_Clr(void);
extern FlagStatus RTC_ISR_DATE_IF_Chk(void);

/* ʱֵBCDʽ غ */
extern void RTC_BCDSEC_Write(uint32_t SetValue);
extern uint32_t RTC_BCDSEC_Read(void);

/* ʱֵBCDʽ غ */
extern void RTC_BCDMIN_Write(uint32_t SetValue);
extern uint32_t RTC_BCDMIN_Read(void);

/* СʱֵBCDʽ غ */
extern void RTC_BCDHOUR_Write(uint32_t SetValue);
extern uint32_t RTC_BCDHOUR_Read(void);

/* ֵBCDʽ غ */
extern void RTC_BCDWEEK_Write(uint32_t SetValue);
extern uint32_t RTC_BCDWEEK_Read(void);

/* ֵBCDʽ غ */
extern void RTC_BCDMONTH_Write(uint32_t SetValue);
extern uint32_t RTC_BCDMONTH_Read(void);

/* ֵBCDʽ غ */
extern void RTC_BCDYEAR_Write(uint32_t SetValue);
extern uint32_t RTC_BCDYEAR_Read(void);

/* ӹʹ (alarm enable)
1ʹAlarm
0ֹAlarm غ */
extern void RTC_ALARM_ALMEN_Setable(FunState NewState);
extern FunState RTC_ALARM_ALMEN_Getable(void);

/* ӵСʱֵ غ */
extern void RTC_ALARM_ALARMHOUR_Set(uint32_t SetValue);
extern uint32_t RTC_ALARM_ALARMHOUR_Get(void);

/* ӵķֵ غ */
extern void RTC_ALARM_ALARMMIN_Set(uint32_t SetValue);
extern uint32_t RTC_ALARM_ALARMMIN_Get(void);

/* ӵֵ غ */
extern void RTC_ALARM_ALARMSEC_Set(uint32_t SetValue);
extern uint32_t RTC_ALARM_ALARMSEC_Get(void);

/* Ƶѡźţ
0000PLLƵõľȷ1뷽 
0001PLLƵĿɱռձȵľȷʱ 
0010λźţߵƽ1s
0011ּλźţߵƽ1s
0100Сʱλźţߵƽ1s
0101λźţߵƽ1s
0110ƥź
0111256뷽ź
1000PLLƵĿɱռձȵľȷʱ
1001λź
1010ּλź
1011Сʱλź
1100λź
1101ƥź
1110PLLƵľȷ1sź
1111RTCڲʱ귽 غ */
extern void RTC_TMSEL_Write(uint32_t SetValue);
extern uint32_t RTC_TMSEL_Read(void);

/* LTBCֵԭʽ غ */
extern void RTC_ADJUST_Write(uint32_t SetValue);
extern uint32_t RTC_ADJUST_Read(void);

/* LTBC
0ʾӼֵ
1ʾټֵ غ */
extern void RTC_ADSIGN_ADSIGN_Set(uint32_t SetValue);
extern uint32_t RTC_ADSIGN_ADSIGN_Get(void);

/* Уʹź
0ʾֹУ
1ʾʹУ غ */
extern void RTC_VCAL_PR1SEN_Setable(FunState NewState);
extern FunState RTC_VCAL_PR1SEN_Getable(void);

/* 
CALSTEP=00/11Чλ8bit3.9ms
CALSTEP=01Чֵ7bit7.8ms
CALSTEP=10Чֵ6bit15.625ms غ */
extern void RTC_MSCNT_Write(uint32_t SetValue);
extern uint32_t RTC_MSCNT_Read(void);

/* LTBCСУѡ
100.06ppm+/-0.03ppm
010.119ppm+/-0.06ppm
00/110.238ppm+/-0.119ppm غ */
extern void RTC_CALSTEP_CALSTEP_Set(uint32_t SetValue);
extern uint32_t RTC_CALSTEP_CALSTEP_Get(void);
extern uint32_t RTC_ADCNT_Read(void);

/*  (sub-second counter register)
15.625ms غ */
extern uint32_t RTC_SSR_Read(void);

/* ʹ (sub-second alarm enable)
1ʹӹ
0ֹӹ غ */
extern void RTC_SSA_SSAEN_Setable(FunState NewState);
extern FunState RTC_SSA_SSAEN_Getable(void);

/*  (sub-second alarm)
SSAEN=1SSRֵSS_ALARMʱжϱ־λ غ */
extern void RTC_SSA_SS_ALARM_Set(uint32_t SetValue);
extern uint32_t RTC_SSA_SS_ALARM_Get(void);

/* RTCʱռձȣ1ڸߵƽȣλĬֵ80msߵƽ غ */
extern void RTC_DTR_Write(uint32_t SetValue);
extern uint32_t RTC_DTR_Read(void);

/* RTCʱӺʹ (RTC_A Enable)
1ʹRTCʱ
0ֹͣRTCʱ

˼ĴſLSCLK룬㣬RTCֹͣʱУܴܲ˼ĴӰ졣 غ */
extern void RTC_CR_RTC_EN_Setable(FunState NewState);
extern FunState RTC_CR_RTC_EN_Getable(void);

extern void RTC_AlarmTime_SetEx(RTC_AlarmTmieTypeDef* para);


//Announce_End
#ifdef __cplusplus
}
#endif

#endif /* __FM33A0XXEV_RTC_H */
