#include "define_all.h"  
#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"
#include "queue.h"
#include "lptim32_timing.h"

/**
  ****************************************************************************************************
  * @file    main.c
  * @author  FMSH Application Team
  * @brief   Header file of  LL Module
  ****************************************************************************************************
  * @attention
  *
  * Copyright (c) [2019] [Fudan Microelectronics]
  * THIS SOFTWARE is licensed under the Mulan PSL v1.
  * can use this software according to the terms and conditions of the Mulan PSL v1.
  * You may obtain a copy of Mulan PSL v1 at:
  * http://license.coscl.org.cn/MulanPSL
  * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND, EITHER EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT, MERCHANTABILITY OR FIT FOR A PARTICULAR
  * PURPOSE.
  * See the Mulan PSL v1 for more details.
  *
  ****************************************************************************************************
  */

#define tskBLINKY_PRIORITY    tskIDLE_PRIORITY+1
void blinky(void *pvParameters)
{
  pvParameters = pvParameters;
  for(;;)
  {
       IWDT_Clr(); 
       LED0_ON;
       vTaskDelay(configTICK_RATE_HZ*2);
       LED0_OFF;
       vTaskDelay(configTICK_RATE_HZ*2);
    
  }
}


int main (void)
{	
	Init_System();				//ϵͳʼ 

	AltFunIO(GPIOG,GPIO_Pin_8,ALTFUN_PULLUP);//SWCLKʹ
	AltFunIO(GPIOG,GPIO_Pin_9,ALTFUN_PULLUP);//SWIOʹ
    LPTIM32_Init();
    xTaskCreate( blinky,       
            "blinky",                 
            configMINIMAL_STACK_SIZE,       
            NULL,                 
            tskBLINKY_PRIORITY,  
            NULL );               
    vTaskStartScheduler();
    while(1)
    {
    }
}


