#include "define_all.h"  
  
//cpuδʱ(ʱ)
void Init_SysTick(void)
{
    CMU->SYSCLKCR &= 0xFFFFFF3F; //systickʱѡSCLK
    SysTick_Config(0x1000000UL);
    SysTick->CTRL  = SysTick_CTRL_CLKSOURCE_Msk |//رж
                    //SysTick_CTRL_TICKINT_Msk |
                    SysTick_CTRL_ENABLE_Msk;
}
//ʱǰSysTick
void TicksDelay(uint32_t ClkNum)
{
    uint32_t last = SysTick->VAL;
    
    ClkNum = ClkNum*clkmode;//ӦͬƵ8Mʱʱ2ms32Mʱʱ0.5ms
    if(ClkNum>0xF00000)
    {
        ClkNum = 0xF00000;
    }
    while(((last - SysTick->VAL)&0xFFFFFFUL ) < ClkNum);
} 
//msʱ
void TicksDelayMs(uint32_t ms , ConditionHook Hook)
{
    uint32_t ClkNum;
    
    ClkNum = (__SYSTEM_CLOCK/1000) ;
    for(;ms>0;ms--)
    {
        if(Hook!=NULL)
        {
            if(Hook()) return ;
        }
        TicksDelay(ClkNum);
    }
}
//usʱ
void TicksDelayUs(uint32_t us)
{
    uint32_t ClkNum;
    
    if(us>100000)//100ms
    {
        us = 100000;
    }
    ClkNum = us*(__SYSTEM_CLOCK/1000000) ;
    TicksDelay(ClkNum);
}

//УĴ
unsigned char CheckSysReg( __IO uint32_t *RegAddr, uint32_t Value )
{
	if( *RegAddr != Value ) 
	{
		*RegAddr = Value;
		return 1;
	}
	else
	{
		return 0;
	}
}

//ѯNVICĴӦжǷ
//1 
//0 ر
unsigned char CheckNvicIrqEn( IRQn_Type IRQn )
{
	if( 0 == ( NVIC->ISER[0U] & ((uint32_t)(1UL << (((uint32_t)(int32_t)IRQn) & 0x1FUL)))) )
		return 0;
	else
		return 1;
}

//GPIOA~G  ģ⹦
void AnalogIO( GPIO_Type* GPIOx, uint32_t GPIO_Pin )
{
	GPIO_InitTypeDef  GPIO_InitStructure;
	GPIO_InitTypeDef  GPIO_InitStructureRun;
  
  GPIO_Get_InitPara(GPIOx, GPIO_Pin, &GPIO_InitStructureRun);
    
  if( (GPIO_InitStructureRun.Pin		!= GPIO_Pin) ||
    (GPIO_InitStructureRun.PxINEN	!= GPIO_IN_Dis) ||
    (GPIO_InitStructureRun.PxODEN	!= GPIO_OD_Dis) ||
    (GPIO_InitStructureRun.PxPUEN	!= GPIO_PU_Dis) ||
    (GPIO_InitStructureRun.PxFCR	!= GPIO_FCR_ANA) )
  {
    GPIO_InitStructure.Pin = GPIO_Pin;
    GPIO_InitStructure.PxINEN = GPIO_IN_Dis;
    GPIO_InitStructure.PxODEN = GPIO_OD_Dis;
    GPIO_InitStructure.PxPUEN = GPIO_PU_Dis;
    GPIO_InitStructure.PxFCR = GPIO_FCR_ANA;
    
    GPIO_Init(GPIOx, &GPIO_InitStructure);	
  }
}

//GPIOH ģ⹦
void AnalogIO_H(uint32_t GPIO_Pin )
{
  uint32_t pinpos = 0x00,pinbit = 0x00;
  
  for (pinpos = 0; pinpos < 4; pinpos++)
  {
    pinbit = ((uint32_t)0x01) << pinpos;
    if(GPIO_Pin & pinbit)
    {
      break;
    }    
  }
  
  CDIF_CR_INTF_EN_Setable(ENABLE);
  GPIOH->INEN &= (~(1<<pinpos));
  GPIOH->FCR |= (3<<(pinpos*2)) ;
  CDIF_CR_INTF_EN_Setable(DISABLE);
}

//GPIOA~G  
//type 0 = ͨ 
//type 1 = 
//#define IN_NORMAL	0
//#define IN_PULLUP	1
void InputtIO( GPIO_Type* GPIOx, uint32_t GPIO_Pin, uint8_t Type )
{
	GPIO_InitTypeDef  GPIO_InitStructure;
	GPIO_InitTypeDef  GPIO_InitStructureRun;
	
	GPIO_Get_InitPara(GPIOx, GPIO_Pin, &GPIO_InitStructureRun);
		
  if( (GPIO_InitStructureRun.Pin		!= GPIO_Pin) ||
    (GPIO_InitStructureRun.PxINEN	!= GPIO_IN_En) ||
    (GPIO_InitStructureRun.PxODEN	!= GPIO_OD_En) ||
    ((Type == IN_NORMAL)&&(GPIO_InitStructureRun.PxPUEN != GPIO_PU_Dis)) ||
    ((Type == IN_PULLUP)&&(GPIO_InitStructureRun.PxPUEN != GPIO_PU_En)) ||
    (GPIO_InitStructureRun.PxFCR	!= GPIO_FCR_IN) )
  {
    GPIO_InitStructure.Pin = GPIO_Pin;	
    GPIO_InitStructure.PxINEN = GPIO_IN_En;
    GPIO_InitStructure.PxODEN = GPIO_OD_En;
    if(Type == IN_NORMAL)		GPIO_InitStructure.PxPUEN = GPIO_PU_Dis;
    else						GPIO_InitStructure.PxPUEN = GPIO_PU_En;	
    GPIO_InitStructure.PxFCR = GPIO_FCR_IN;
    
    GPIO_Init(GPIOx, &GPIO_InitStructure);	
  }
}

//GPIOH  
//type 0 = ͨ 
//type 1 = 
//#define IN_NORMAL	0
//#define IN_PULLUP	1
void InputtIO_H(uint32_t GPIO_Pin, uint8_t Type )
{
  uint32_t pinpos = 0x00,pinbit = 0x00;
  
  for (pinpos = 0; pinpos < 4; pinpos++)
  {
    pinbit = ((uint32_t)0x01) << pinpos;
    if(GPIO_Pin & pinbit)
    {
      break;
    }    
  }
  
   CDIF_CR_INTF_EN_Setable(ENABLE);
   if(Type==0)
   {
     GPIOH->PUEN &= (~(1<<pinpos));
   }
   else
   {
     GPIOH->PUEN |= (1<<pinpos);
   }
   GPIOH->FCR &= (~(3<<(pinpos*2)));
   GPIOH->INEN |= (1<<pinpos);    
   CDIF_CR_INTF_EN_Setable(DISABLE);
}

//GPIOA~G 
//type 0 = ͨ 
//type 1 = OD
//#define OUT_PUSHPULL	0
//#define OUT_OPENDRAIN	1
void OutputIO( GPIO_Type* GPIOx, uint32_t GPIO_Pin, uint8_t Type )
{
	GPIO_InitTypeDef  GPIO_InitStructure;
	GPIO_InitTypeDef  GPIO_InitStructureRun;
	
	GPIO_Get_InitPara(GPIOx, GPIO_Pin, &GPIO_InitStructureRun);
 
  if( (GPIO_InitStructureRun.Pin		!= GPIO_Pin) ||
    (GPIO_InitStructureRun.PxINEN	!= GPIO_IN_Dis) ||
    ((Type == OUT_PUSHPULL)&&(GPIO_InitStructureRun.PxODEN	!= GPIO_OD_Dis)) ||
    ((Type == OUT_OPENDRAIN)&&(GPIO_InitStructureRun.PxODEN	!= GPIO_OD_En)) ||
    (GPIO_InitStructureRun.PxPUEN	!= GPIO_PU_Dis) ||
    (GPIO_InitStructureRun.PxFCR	!= GPIO_FCR_OUT) )
  {
    GPIO_InitStructure.Pin = GPIO_Pin;
    GPIO_InitStructure.PxINEN = GPIO_IN_Dis;
    if(Type == OUT_PUSHPULL)	GPIO_InitStructure.PxODEN = GPIO_OD_Dis;
    else						GPIO_InitStructure.PxODEN = GPIO_OD_En;
    GPIO_InitStructure.PxPUEN = GPIO_PU_Dis;
    GPIO_InitStructure.PxFCR = GPIO_FCR_OUT;
     
    GPIO_Init(GPIOx, &GPIO_InitStructure);		
  }
}

//GPIOH 
void OutputIO_H(uint32_t GPIO_Pin)
{
  uint32_t pinpos = 0x00,pinbit = 0x00;
  
  for (pinpos = 0; pinpos < 4; pinpos++)
  { 
    pinbit = ((uint32_t)0x01) << pinpos;
    if(GPIO_Pin & pinbit)
    {
      break;
    }    
  }
  CDIF_CR_INTF_EN_Setable(ENABLE);
  GPIOH->INEN &= (~(1<<pinpos));
  GPIOH->PUEN &= (~(1<<pinpos));
  GPIOH->FCR &= (~(3<<(pinpos*2)));
  GPIOH->FCR |= (1<<(pinpos*2));
  CDIF_CR_INTF_EN_Setable(DISABLE);
}

//IO⹦ܿ 
//type 0 = ͨ 
//type 1 = OD (ODܽ⹦֧)
//type 2 = ͨ+ 
//type 3 = OD+
//#define ALTFUN_NORMAL				0
//#define ALTFUN_OPENDRAIN			1
//#define ALTFUN_PULLUP				2
//#define ALTFUN_OPENDRAIN_PULLUP	3
void AltFunIO( GPIO_Type* GPIOx, uint32_t GPIO_Pin, uint8_t Type  )
{																
	GPIO_InitTypeDef  GPIO_InitStructure;
	GPIO_InitTypeDef  GPIO_InitStructureRun;
	
	GPIO_Get_InitPara(GPIOx, GPIO_Pin, &GPIO_InitStructureRun);
  
  if( (GPIO_InitStructureRun.Pin		!= GPIO_Pin) ||
    (GPIO_InitStructureRun.PxINEN	!= GPIO_IN_Dis) ||
    (((Type & 0x01) == 0)&&(GPIO_InitStructureRun.PxODEN	!= GPIO_OD_Dis)) ||
    (((Type & 0x01) != 0)&&(GPIO_InitStructureRun.PxODEN	!= GPIO_OD_En)) ||
    (((Type & 0x02) == 0)&&(GPIO_InitStructureRun.PxPUEN	!= GPIO_PU_Dis)) ||
    (((Type & 0x02) != 0)&&(GPIO_InitStructureRun.PxPUEN	!= GPIO_PU_En)) ||
    (GPIO_InitStructureRun.PxFCR	!= GPIO_FCR_DIG) )
  {
    GPIO_InitStructure.Pin = GPIO_Pin;
    GPIO_InitStructure.PxINEN = GPIO_IN_Dis;
    if( (Type & 0x01) == 0 )	GPIO_InitStructure.PxODEN = GPIO_OD_Dis;
    else						GPIO_InitStructure.PxODEN = GPIO_OD_En;
    if( (Type & 0x02) == 0 )	GPIO_InitStructure.PxPUEN = GPIO_PU_Dis;
    else						GPIO_InitStructure.PxPUEN = GPIO_PU_En;	
    GPIO_InitStructure.PxFCR = GPIO_FCR_DIG;
     
    GPIO_Init(GPIOx, &GPIO_InitStructure);		
  }
}

//IO⹦ܿ 
//type 0 = ͨ 
//type 1= ͨ+ 
void AltFunIO_H(uint32_t GPIO_Pin, uint8_t Type  )
{																
   uint32_t pinpos = 0x00,pinbit = 0x00;
  
   for (pinpos = 0; pinpos < 4; pinpos++)
   { 
     pinbit = ((uint32_t)0x01) << pinpos;
     if(GPIO_Pin & pinbit)
     {
       break;
     }    
   }
  
   CDIF_CR_INTF_EN_Setable(ENABLE);
   GPIOH->INEN &= (~(1<<pinpos));
   if(Type==0)
   {
     GPIOH->PUEN &= (~(1<<pinpos));
   }
   else
   {
     GPIOH->PUEN |= (1<<pinpos);
   }
   GPIOH->FCR &= (~(3<<(pinpos*2)));
   GPIOH->FCR |= (2<<(pinpos*2));
   CDIF_CR_INTF_EN_Setable(DISABLE);
}

//IOرգodߣ
//IOΪ̬
void CloseIO( GPIO_Type* GPIOx, uint32_t GPIO_Pin )
{
	uint32_t pinpos = 0x00,pinbit = 0x00;
  
  for (pinpos = 0; pinpos < 16; pinpos++)
  { 
    pinbit = ((uint32_t)0x01) << pinpos;
    if(GPIO_Pin & pinbit)
    {
      break;
    }    
  }
  		
	GPIOx->INEN &=~(1<<pinpos);
  GPIOx->FCR  &= ~(3<<(pinpos*2));
}

void IWDT_Clr(void)
{
  IWDT ->SERV =0x12345A5A;
}

void IWDT_Init(void)
{
  CMU_PERCLK_SetableEx(IWDTCLK, ENABLE); 
  IWDT->CFGR =0x06;  //2S4096S
  IWDT_Clr();
}

void LED0_Flash(uint08 Times)
{
	uint08 i;
  
	CMU_PERCLK_SetableEx(PADCLK, ENABLE);  
  OutputIO(LED0_GPIO,LED0_PIN,0 );
  
	for( i=0; i<Times; i++ )
	{
    LED0_ON;
		TicksDelayMs( 100, NULL );		
		LED0_OFF;
		TicksDelayMs( 100, NULL );	
	}
}

//ϵͳʱ
//ʹRCHFʱ,define_all.h SYSCLKdefϵͳʱƵ
void Init_SysClk(void)
{
	CMU_SYSCLK_InitTypeDef SYSCLK_InitStruct;
		
	SYSCLK_InitStruct.SYSCLKSEL =  CMU_SYSCLKCR_SYSCLKSEL_RCHF;	//ѡRCHFʱ
	SYSCLK_InitStruct.AHBPRES =    CMU_SYSCLKCR_AHBPRES_DIV1;		//AHBƵ
	SYSCLK_InitStruct.APBPRES =   CMU_SYSCLKCR_APBPRES_DIV1;		//APB1Ƶ
	SYSCLK_InitStruct.SLP_ENEXTI = ENABLE;//ģʽʹⲿжϲ	
	CMU_SysClk_Init(&SYSCLK_InitStruct);
}

void Init_RCHF(void)
{
  CMU_RCHF_InitTypeDef RCHF_InitStruct;
  
  RCHF_InitStruct.FSEL = SYSCLKdef;//define_all.h SYSCLKdefϵͳʱƵ
	RCHF_InitStruct.RCHFEN = ENABLE;//RCHF
	
	CMU_RCHF_Init(&RCHF_InitStruct);
  
  CMU_Init_RCHF_Trim(clkmode);//RCHFУ׼ֵ(оƬλԶ8MУ׼ֵ)ֻǵУRCHF¾  
}

void Init_SysClk_Gen( void )				//ʱѡ
{	  
	/*ϵͳʱӳ24MҪwait*/
	if( RCHFCLKCFG > 24 )
  {
      FLS_RDCR_WAIT_Set(FLS_RDCR_WAIT_1CYCLE);
      if( RCHFCLKCFG >= 48)  
      {
          FLS_RDCR_WAIT_Set(FLS_RDCR_WAIT_2CYCLE);
      }
  } 
	else 
  {
      FLS_RDCR_WAIT_Set(FLS_RDCR_WAIT_0CYCLE);
  }	
  
  Init_RCHF();
  
  /*ϵͳʱ*/
	Init_SysClk();	
}

void DEBUG_Init(void)
{
  DBG->CR =0x3; //DEBUGʱرIWDT WWDTʱԭ״̬ 
}

void Init_System(void)
{		
	/*ϵͳ*/
  __disable_irq();			//رȫжʹ
  IWDT_Init();				//ϵͳŹ Ҫƣ
  IWDT_Clr();  				//ϵͳŹ	
	Init_SysTick();				//cpuδʱ(ʱ)	
	TicksDelayMs( 10, NULL );	//ʱ,ϵͳϵҪ̽ʱлΪRCHF8MҲҪ̽߷ܵ޷س
	
  Init_SysClk_Gen();			//ϵͳʱ	
  
	/*µ縴λ*/
	//pdrborµ縴λҪһ
	//Դѹµ縴λѹʱоƬᱻλס		
	//pdrѹλ׼ǹļͣ޷
	//borѹλ׼ȷҪ2uA
	RMU_PDRCR_PDREN_Setable(ENABLE);		//PDR
	RMU_BORCR_OFF_BOR_Setable(DISABLE);	//BOR
  
  DEBUG_Init();
  
  /*RTCֵĴ*/
  /*УֵλǸϵǸϴֵӰRTC*/
  /*ӦûRTCУҪЩעͷſ*/
//  CMU_PERCLK_SetableEx(RTCCLK, ENABLE); 
//  RTC_ADJUST_Write(0);//RTCʱ¶Ȳֵд0粻ĴֵһRTCʱӿܻƫǳ
//  CMU_PERCLK_SetableEx(RTCCLK, DISABLE); 
   
  /*׼ѭ*/
	TicksDelayMs( 100, NULL );	//ʱ
	
	LED0_Flash(5);				//ʱ
  
	__enable_irq();				//ȫжʹ
}
